﻿using EasyHook;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TinkerWorX.DllInjectExample
{
    public class EntryPoint : IEntryPoint
    {
        [UnmanagedFunctionPointer(CallingConvention.Winapi, SetLastError = true, CharSet = CharSet.Ansi)]
        private delegate IntPtr LoadLibraryAPrototype(String fileName);
        private LoadLibraryAPrototype LoadLibraryA;
        private LocalHook LoadLibraryALocalHook;

        public EntryPoint(RemoteHooking.IContext hookingContext) { }

        public void Run(RemoteHooking.IContext hookingContext)
        {
            var address = LocalHook.GetProcAddress("kernel32.dll", "LoadLibraryA");
            this.LoadLibraryA = Marshal.GetDelegateForFunctionPointer<LoadLibraryAPrototype>(address);
            this.LoadLibraryALocalHook = LocalHook.Create(address, new LoadLibraryAPrototype(this.LoadLibraryAHook), null);

            // toy a bit with these, not 100% sure what they do
            //this.LoadLibraryALocalHook.ThreadACL.SetInclusiveACL(new[] { 0 });
            this.LoadLibraryALocalHook.ThreadACL.SetExclusiveACL(new[] { 0 });

            // Everyone has had their chance to inject stuff,
            // time to wake up the process.
            RemoteHooking.WakeUpProcess();

            // Let the thread stay alive, so all hooks stay alive as well.
            // This might need to be shutdown properly on exit.
            Thread.Sleep(Timeout.Infinite);
        }

        private IntPtr LoadLibraryAHook(String fileName)
        {
            var result = this.LoadLibraryA(fileName);

            if(fileName == "lib1.dll")
            {
                // inject more hooks here.
            }

            return result;
        }
    }
}
